'use strict';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = exports.update = exports.put = exports.scan = exports.get = exports.query = void 0;

const query = client => table => async (options = {}) => {
  const repsonse = await client.query(_objectSpread({
    TableName: table
  }, options)).promise();
  return repsonse.Item;
};

exports.query = query;

const get = client => table => async (key, options = {}) => {
  const repsonse = await client.get(_objectSpread({
    TableName: table,
    Key: key
  }, options)).promise();
  return repsonse.Item;
};

exports.get = get;

const scan = client => table => async (options = {}, previous = []) => {
  const repsonse = await client.scan(_objectSpread({
    TableName: table
  }, options)).promise();
  const items = [...previous, ...repsonse.Items];
  const lastKey = repsonse.LastEvaluatedKey;
  if (!lastKey) return items;
  return scan(_objectSpread({}, options, {
    ExclusiveStartKey: lastKey
  }), items);
};

exports.scan = scan;

const put = client => table => async ({
  key,
  data = {}
}, options = {}) => {
  const item = _objectSpread({}, key, data);

  await client.put(_objectSpread({
    TableName: table,
    Item: item
  }, options)).promise();
  return item;
};

exports.put = put;

const update = client => table => async (key, options = {}) => {
  const repsonse = await client.update(_objectSpread({
    TableName: table,
    Key: key,
    ReturnValues: 'ALL_NEW'
  }, options)).promise();
  return repsonse.Attributes;
};

exports.update = update;

const remove = client => table => async (key, options = {}) => {
  const repsonse = await client.delete(_objectSpread({
    TableName: table,
    Key: key,
    ReturnValues: 'ALL_OLD'
  }, options)).promise();
  return repsonse.Attributes;
};

exports.remove = remove;
//# sourceMappingURL=index.js.map
